package com.bjsxt.web.servlet;

import com.bjsxt.commens.constant;
import com.bjsxt.exception.UserNotFoundException;
import com.bjsxt.pojo.Users;
import com.bjsxt.service.Impl.UserLoginServiceImpl;
import com.bjsxt.service.UserLoginService;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

@WebServlet("/login.do")
public class UserLoginServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req,resp);
    }
    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String username = req.getParameter("username");
        String userpwd = req.getParameter("userpwd");
        String code= req.getParameter("code");
        try{
            HttpSession session = req.getSession();
            UserLoginService userLoginService=new UserLoginServiceImpl();
            Users users = userLoginService.userLogin(username, userpwd);
            String codeTemp = (String)session.getAttribute(constant.VALIDATE_CODE_KEY);
            if(codeTemp.equals(code)){
                // 建立客户端和服务端的会话状态维持
                session.setAttribute(constant.USER_SESSION_KEY,users);
                ServletContext servletContext=this.getServletContext();
                HttpSession temp=(HttpSession) servletContext.getAttribute(users.getUserid()+"");
                if (temp != null) {
                    servletContext.removeAttribute(users.getUserid()+"");
                    temp.invalidate();
                }
                servletContext.setAttribute(users.getUserid()+"",session);
                //使用重定向方式跳转首页
                resp.sendRedirect("main.jsp");
            }else{
                req.setAttribute(constant.REQUEST_MSG,"验证码错误，请重新输入！");
                req.getRequestDispatcher("login.jsp").forward(req,resp);
            }
        }catch(UserNotFoundException e){
            req.setAttribute("msg",e.getMessage());
            req.getRequestDispatcher("login.jsp").forward(req,resp);
        }catch(Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }
    }
}
